#include <stdio.h>

/* a) dio */
/* vracamo najmanji indeks t.d. tri uzastopne znamenke broja a cine prost broj
   u bazi b */
int trojke(int a, int b) {
  int mini = -1;

  /* uvjet: imamo dovoljno znamenki preostalo! */
  /* alternativa: prvo prebrojimo znamenke, pa for petlja */
  int i = -1;
  while(a / (b*b) > 0) {
    int prost;
    int broj;
    int prva, druga, treca;
    int j;

    /* rezemo sljedecu znamenku, gledamo dvije unaprijed */
    prva = a % b;

    a /= b; /* pomaknemo se na sljedecu znamenku */
    ++i; /* u prvom koraku, i = 0 */

    druga = a % b;
    treca = (a/b) % b;

    /* uocimo da se broj 10 se spominje u kodu! */

    /* prva = uz najmanju potenciju */
    broj = prva + druga*b + treca*b*b;

    /*
      alternativno (i jednostavnije) rjesenje:
      broj = a % (b*b*b)
    */

    /* testni ispis */
    printf("znamenke: %d %d %d\n", treca, druga, prva);
    printf("broj: %d\n", broj);

    /* gledamo da li je broj prost */
    prost = broj > 1;
    for (j = 2; j < broj; ++j) {
      if (broj % j == 0) {
        prost = 0;
        break;
      }
    }

    if (prost) {
      /* izadjemo cim nadjemo prvi prosti */
      mini = i;
      break;
    }
  }

  return mini;
}

/* b) dio */
int main(void) {
  int n1, n2;
  int maxi = -1;
  int maxn;
  int b;
  scanf("%d %d", &n1, &n2);
  scanf("%d\n", &b);

  for (; n1 <= n2; n1++) {
    int idx = trojke(n1, b);
    if (idx == -1)
      continue;

    if (maxi == -1 || maxi < idx) {
      maxi = idx;
      maxn = n1;
    }
  }

  if (maxi != -1) {
    printf("%d\n", maxn);
  } else {
    printf("nema takvog\n");
  }

  return 0;
}
