(ova rješenja nisu optimalna, manje-više sliče najčešćim njihovim točnim rješenjima)


// 1. grupa (prepisivači)
int ispravak(int bodovi[], int raspored[], int n)
{
    int i, j, c = 0;
    for (i = 0; i < n; ++i)
        for (j = i + 1; j < n; ++j)
            if (bodovi[i] > 0 && bodovi[i] == bodovi[j] && raspored[i] == raspored[j])
            {
                bodovi[i] = bodovi[j] = 0;
                c += 2;
            }
    return c;
}

void izvjestaj(int bodovi[], int n, int *min, int *br)
{
    int i;
    *min = bodovi[0];
    *br = 0;
    for (i = 0; i < n; ++i)
    {
        if (bodovi[i] < *min)
        {
            *min = bodovi[i];
            *br = 0;
        }
        if (bodovi[i] == *min)
            ++*br;
    }
}
// poziv: izvjestaj(bodovi, n, &min, &br);




// 2. grupa (šah)
int rating(double elo[], int stol[], int n)
{
    int i, j, c = 0;
    for (i = 0; i < n; ++i)
        for (j = i + 1; j < n; ++j)
            if (stol[i] > 0 && stol[i] == stol[j])
                if (elo[i] > elo[j])
                {
                    elo[i] += 5; elo[j] -= 5; ++c;
                }
                else if (elo[i] < elo[j])
                {
                    elo[i] -= 5; elo[j] += 5; ++c;
                }
    return c;
}

void sahisti(double elo[], int n, double *max, double *prosjek)
{
    int i;
    *max = elo[0];
    *prosjek = 0;
    for (i = 0; i < n; ++i)
    {
        if (elo[i] > *max)
            *max = elo[i];
        *prosjek += elo[i];
    }
    *prosjek = *prosjek / n;
}
// poziv: sahisti(elo, n, &max, &prosjek);




// 3.grupa (igra)
int igra(double snaga[], int pozicija[], int n)
{
    int i, j, c = 0;
    for (i = 0; i < n; ++i)
        for (j = i + 1; j < n; ++j)
            if (pozicija[i] == pozicija[j])
            {
                c += 2;
                if (snaga[i] > snaga[j])
                    snaga[j] = 0; 
                else if (snaga[i] < snaga[j])
                    snaga[i] = 0; 
                else
                    snaga[i] = snaga[j] = 0;
            }
    return c;
}

void izvjestaj(double snaga[], int n, double *max, int *br)
{
    int i;
    *max = snaga[0];
    *br = 0;
    for (i = 0; i < n; ++i)
    {
        if (snaga[i] > *max)
            *max = snaga[i];
        if (snaga[i] == 0)
            ++*br;
    }
}
// poziv: izvjestaj(snaga, n, &max, &br);




// 4. grupa (rukomet)
int rating(int bodovi[], int utakmica[], int n)
{
    int i, j, c = 0;
    for (i = 0; i < n; ++i)
        for (j = i + 1; j < n; ++j)
            if (utakmica[i] > 0 && utakmica[i] == utakmica[j])
                if (bodovi[i] > bodovi[j])
                {
                    bodovi[i] += 2; ++c;
                }
                else if (bodovi[i] < bodovi[j])
                {
                    bodovi[j] += 2; ++c;
                }
                else
                {
                    ++bodovi[i]; ++bodovi[j]; c += 2;
                }
    return c;
}

void izvjestaj(int bodovi[], int n, int *max, int *br)
{
    int i;
    *max = bodovi[0];
    *br = 0;
    for (i = 0; i < n; ++i)
    {
        if (bodovi[i] > *max)
        {
            *max = bodovi[i];
            *br = 0;
        }
        if (bodovi[i] == *max)
            ++*br;
    }
}
