#include<stdio.h>
int kratnost(int p, int a)
{
    int k=0;
    while(a%p==0) {a=a/p; ++k;}
    return k;
}


int manji(int a, int b, int p)
{
    int ka=kratnost(p,a), kb=kratnost(p,b);
    if( (ka<kb) || ((ka==kb)&&(a<b)) ) return 1;
    return 0;

}


int veci(int a, int b, int p)
{
    if(!manji(a,b,p) && a!=b  ) return 1;
    return 0;
}


void sortp(int* niz, int n, int p)
{
    int i,j,t;
    for(i=0;i<n-1;i++){
        for(j=i+1;j<n;j++)
        {if(veci(niz[i],niz[j],p)) {t=niz[i]; niz[i]=niz[j]; niz[j]=t;}  }
    }

}


int koliko_je_manjih_linearno(int m, int* niz, int n, int p)
{
    int i=0;
    while((i<n)&&(manji(niz[i],m,p))) ++i;
    return i;
}





int koliko_je_manjih_binarno(int m, int* niz, int n, int p)
{
    int pocetak=0,kraj=n-1; int sredina;
    while(pocetak<=kraj)
    {
        sredina=(pocetak+kraj)/2;
        if(manji(niz[sredina],m,p)) pocetak=sredina+1;
        else kraj=sredina-1;
    }
    return pocetak;
}





int main()
{
    int i,m=9,p=3, n, niz[]={1,1,1,2,3,4,6,21,9,9,9,9,10,11,12,36}, pocetak, kraj;
    n=sizeof(niz)/sizeof(int);

    sortp(niz,n,p);

    printf("duljina niza je %d\n",n);

    for(i=0;i<n;i++)  printf(" %d",niz[i]);


    printf("\n%d", koliko_je_manjih_linearno(m,niz,n,p));

    printf("\n%d", koliko_je_manjih_binarno(m,niz,n,p));    //BONUS


    return 0;
}
