#include<stdio.h>
int kratnost(int r, int a)
{
    int k=0;
    while(a%r==0) {a=a/r; ++k;}
    return k;
}


int manji(int i, int j, int r)
{
    int ki=kratnost(r,i), kj=kratnost(r,j);
    if( (ki>kj) || ((ki==kj)&&(i<j)) ) return 1;
    return 0;

}


int veci(int a, int b, int r)
{
    if(!manji(a,b,r) && a!=b  ) return 1;
    return 0;
}


void sortp(int* niz, int n, int r)
{
    int i,j,t;
    for(i=0;i<n-1;i++){
        for(j=i+1;j<n;j++)
        {if(veci(niz[i],niz[j],r)) {t=niz[i]; niz[i]=niz[j]; niz[j]=t;}  }
    }

}


int koliko_je_manjih_linearno(int m, int* niz, int n, int r)
{
    int i=n-1;
    while((i>=0)&&(veci(niz[i],m,r))) --i;
    return n-(i+1);
}





int koliko_je_manjih_binarno(int m, int* niz, int n, int r)
{
    int pocetak=0,kraj=n-1; int sredina;
    while(pocetak<=kraj)
    {
        sredina=(pocetak+kraj)/2;
        if(veci(niz[sredina],m,r)) kraj=sredina-1;
        else pocetak=sredina+1;
    }
    return n-(kraj+1);
}





int main()
{
    int i,m=9,r=3, n, niz[]={1,1,1,2,3,4,6,21,9,9,9,9,10,11,12,36,81}, pocetak, kraj;
    n=sizeof(niz)/sizeof(int);

    sortp(niz,n,r);

    printf("duljina niza je %d\n",n);

    for(i=0;i<n;i++)  printf(" %d",niz[i]);


    printf("\n%d", koliko_je_manjih_linearno(m,niz,n,r));

    printf("\n%d", koliko_je_manjih_binarno(m,niz,n,r));    //BONUS


    return 0;
}
